<template>
	<div class="focus:outline-none">
		<MkPageSpinner v-if="pageLoading" />
		<div v-if="!addShipping && !addPayment">
			<div class="mx-auto w-full md:w-690 lg:w-960 md:rounded-lg lg:rounded bg-white px-4 pt-4 pb-6 md:p-6 lg:p-14">
				<div class="flex flex-col md:flex-row justify-between md:items-center">
					<h2
						class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
					>
						Address
					</h2>
					<div class="mt-6 md:mt-0 flex justify-center">
						<MkTerritoryButton
							ref="add_new_address_button"
							mkterritory-width="min-w-150"
							button-title="Add new address"
							class="focus:ring-black focus:ring-1 h-8 items-center text-sm leading-5 pt-2 pb-1.5"
							font-size="text-sm"
							@click="addCard('address')"
						/>
					</div>
				</div>
				<div
					:class="
						CUSTOMER_SHIPPING_ADDRESS.length ? 'grid grid-flow-row mt-8 lg:mt-12 grid-cols-12 gap-y-8 md:gap-y-10' : ''
					"
				>
					<div
						v-for="(content, i) in CUSTOMER_SHIPPING_ADDRESS"
						:key="i"
						class="md:w-44 col-span-12 md:col-span-4 lg:col-span-3"
					>
						<p class="font-primary-font-bold text-base leading-6">
							{{ content.firstName + ' ' + content.lastName }}
						</p>
						<p class="font-primary-font-light text-base leading-6 lg:leading-5 mt-2">
							{{ content.streetName }}
						</p>
						<p class="font-primary-font-light text-base leading-6 lg:leading-5 mt-2">
							{{ content.streetNumber ? content.streetNumber : ' ' }}
						</p>
						<p class="font-primary-font-light text-base leading-6 lg:leading-5 mt-2">
							{{ content.city + ',' + (content.state || '') + ' ' + content.postalCode }}
						</p>
						<p class="font-primary-font-light text-base leading-6 lg:leading-5 mt-2">
							{{ content.phone | phone }}
						</p>
						<div class="flex flex-row items-center mt-2">
							<a
								ref="delete-address-btn"
								class="w-3 md:w-2.5 lg:w-3.5 cursor-pointer focus:ring-black focus:ring-1"
								tabindex="0"
								role="button"
								:aria-label="content.firstName + content.lastName + ' ' + `Delete`"
								@click="deleteCard(content, 'address', i)"
								@keydown.enter="deleteCard(content, 'address', i)"
								><img src="~/assets/images/icons-delete.svg" class="w-full btn-focus" alt=""
							/></a>
						</div>
					</div>
				</div>
			</div>
			<div
				class="mt-2 md:mt-8 lg:mt-10 mx-auto w-full md:w-690 lg:w-960 md:rounded-lg lg:rounded bg-white px-4 pt-4 pb-6 md:p-6 lg:p-14"
			>
				<div class="flex flex-col md:flex-row justify-between md:items-center">
					<h2
						class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
					>
						Payment
					</h2>
					<div class="mt-6 md:mt-0 flex justify-center">
						<MkTerritoryButton
							ref="add_new_card_button"
							mkterritory-width="min-w-150"
							button-title="Add new card"
							class="focus:ring-black focus:ring-1 h-8 items-center text-sm leading-5 pt-2 pb-1.5"
							font-size="text-sm"
							@click="addCard('payment')"
						/>
					</div>
				</div>
				<div
					:class="
						CUSTOMER_CREDIT_CARD_DETAILS.length
							? 'grid grid-flow-row mt-8 lg:mt-12 grid-cols-12 gap-y-8 md:gap-y-10'
							: ''
					"
				>
					<div
						v-for="(item, index) in CUSTOMER_CREDIT_CARD_DETAILS"
						:key="index"
						class="md:w-44 col-span-12 md:col-span-4 lg:col-span-3"
					>
						<p class="font-primary-font-bold text-base leading-5 uppercase"> {{ item.brand }} {{ item.last4 }} </p>
						<p v-if="item.expiredStatus" class="font-primary-font-bold leading-6 text-error-20 mt-1 md:mt-2">
							Payment declined
						</p>
						<p class="font-primary-font-light text-base leading-5 mt-2">
							{{ (item.defaultBillingAddress && item.defaultBillingAddress['streetName']) || '' }}
						</p>
						<p class="font-primary-font-light text-base leading-5 mt-2">
							{{
								item.defaultBillingAddress && item.defaultBillingAddress['streetNumber']
									? item.defaultBillingAddress['streetNumber']
									: ''
							}}
						</p>
						<p class="font-primary-font-light text-base leading-5 mt-2">
							{{ (item.defaultBillingAddress && item.defaultBillingAddress['city']) || '' }},
							{{ (item.defaultBillingAddress && item.defaultBillingAddress['state']) || '' }}
							{{ (item.defaultBillingAddress && item.defaultBillingAddress['postalCode']) || '' }}
						</p>
						<p class="font-primary-font-light text-base leading-5 mt-2">
							{{ item.defaultBillingAddress && item.defaultBillingAddress['phone'] | phone }}
						</p>
						<div class="flex flex-row items-center" :class="item.expiredStatus ? 'mt-4' : 'mt-2'">
							<MkPrimaryButton
								v-if="item.expiredStatus"
								button-title="Update"
								btn-class="h-8 w-36 -ml-0.5"
								@click="editCard(item)"
								@keydown.enter="editCard(item)"
							/>
							<a
								v-else
								ref="edit-payment-btn"
								class="w-5 mr-6 focus:ring-black cursor-pointer focus:ring-1"
								tabindex="0"
								role="button"
								:aria-label="item.brand + item.last4 + ' ' + `Edit`"
								@click="editCard(item, index)"
								@keydown.enter="editCard(item, index)"
								><img src="~/assets/images/edit-icon.svg" class="w-full btn-focus" alt=""
							/></a>
							<a
								ref="delete-payment-btn"
								class="w-3 md:w-2.5 lg:w-3.5 focus:ring-black cursor-pointer focus:ring-1"
								tabindex="0"
								role="button"
								:aria-label="item.brand + item.last4 + ' ' + `Delete`"
								@click="deleteCard(item, 'payment', index)"
								@keydown.enter="deleteCard(item, 'payment', index)"
								><img src="~/assets/images/icons-delete.svg" class="w-full btn-focus" alt=" "
							/></a>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div
			v-if="addShipping || addPayment"
			class="w-full md:w-690 lg:w-722 md:rounded-lg lg:rounded bg-white px-4 pt-4 pb-6 md:p-6 lg:p-14"
		>
			<div v-if="addShipping">
				<div class="flex flex-row justify-between items-center md:items-end">
					<h2
						id="add_new_address"
						class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
					>
						Add new address
					</h2>
				</div>
				<ValidationObserver ref="form_validation_observer">
					<div role="group" aria-labelledby="add_new_address">
						<MkAddressForm
							id="checkout_shipping_form"
							v-model="inputAddress"
							set-focus="true"
							:address-data="inputAddress"
							class="mt-8 md:mt-6 lg:mt-6 w-full"
						/>
					</div>
					<div class="flex flex-col justify-center items-center mt-8 lg:mt-10">
						<MkPrimaryButton
							btn-class="min-w-150 h-10 py-3"
							aria-labelledby="new_address_success_message"
							:disabled="disableTrue"
							:loading="loading"
							button-title="Save"
							font-size="text-xl"
							@click="updateCustomer()"
						/>
						<span
							id="new_address_success_message"
							ref="new_address_success_message"
							aria-hidden="true"
							role="alert"
							aria-live="polite"
							class="sr-only"
						></span>

						<div class="pt-8 md:pt-6">
							<button
								ref="address_cancel_button"
								tabindex="0"
								class="focus:outline-none focus:ring-1 focus:ring-black font-primary-font-bold text-sm md:text-base leading-6 edit-button cursor-pointer"
								@click="(addShipping = false), addCancel()"
							>
								Cancel
							</button>
						</div>
					</div>
				</ValidationObserver>
			</div>
			<div v-if="addPayment">
				<div class="flex flex-row justify-between items-center md:items-end">
					<h2 class="font-secondary-font-regular text-xl lg:text-base2 leading-6 lg:leading-10">
						{{ action == 'UPDATE_PAYMENT' ? 'Edit Payment' : 'Add new card' }}
					</h2>
				</div>
				<div
					v-if="paymentData.expiredStatus"
					class="h-14 px-6 w-full bg-error-10 rounded flex items-center text-base font-primary-font-regular mt-12"
				>
					<p>
						<span class="font-primary-font-bold">There was an issue processing your payment.</span>
						Please update payment info.
					</p>
				</div>
				<ValidationObserver ref="form_validation_observer">
					<h3 v-if="action == 'ADD_PAYMENT'" class="mt-8 lg:mt-12 font-primary-font-bold text-base leading-6">
						Credit card
					</h3>
					<MkCheck
						v-if="action == 'UPDATE_PAYMENT'"
						:checked="editCreaditCard"
						radio-title="Edit card number"
						class="mr-3 mt-8"
						@change="selectCard"
					/>
					<MKAdyen
						v-if="
							this.$store.state.paymentGateway === 'adyen' &&
							((action === 'UPDATE_PAYMENT' && editCreaditCard === true) || action === 'ADD_PAYMENT')
						"
					/>
					<MkAddNewCreditcard
						v-else-if="(action === 'UPDATE_PAYMENT' && editCreaditCard === true) || action === 'ADD_PAYMENT'"
					/>
					<div v-if="action === 'UPDATE_PAYMENT' && editCreaditCard === false" class="mt-8">
						<h3 class="text-base font-bold uppercase"> {{ paymentData.brand }} {{ paymentData.last4 }} </h3>
						<p class="text-sm">
							exp: <span>{{ paymentData.expiry | monthFormatter }}</span>
						</p>
					</div>
					<div class="flex flex-row justify-between items-center md:items-end">
						<h3 id="Billing_address" class="mt-10 lg:mt-12 font-primary-font-bold text-base leading-6 lg:leading-10">
							Billing address
						</h3>
					</div>
					<div role="group" aria-labelledby="Billing_address">
						<MkAddressForm
							id="checkout_billing_form"
							v-model="inputAddress"
							set-focus="false"
							:address-data="inputAddress"
						/>
					</div>
					<div class="flex flex-col justify-center items-center mt-8 lg:mt-10">
						<MkPrimaryButton
							btn-class="min-w-150 h-10 py-3"
							:disabled="disableTrue"
							:loading="loading"
							:button-title="buttonTitle"
							font-size="text-xl"
							@click="updateCustomer()"
						/>
						<div class="pt-8 md:pt-6">
							<button
								ref="cancel_button"
								tabindex="0"
								class="focus:outline-none focus:ring-1 focus:ring-black font-primary-font-bold text-sm md:text-base leading-6 edit-button cursor-pointer"
								@click="(addPayment = false), addNewCardFocus($event)"
							>
								Cancel
							</button>
						</div>
					</div>
				</ValidationObserver>
			</div>
		</div>
		<MkModal
			:header-title="title"
			:toggle-modal="showModal && deleteModal"
			model-class="max-w-full md:max-w-md lg:max-w-xl items-center h-auto"
			modal-height="h-auto"
			modal-style="mx-4 md:mx-0 px-8"
			:focus-close="focusClose"
			@close-modal="deleteCardFocus(type)"
		>
			<template #modalContent>
				<h2
					class="text-2xl lg:text-base2 font-secondary-font-regular leading-7 lg:leading-10 pb-8 md:pb-6 tracking-normal"
				>
					{{ title }}
				</h2>
				<p
					class="text-base md:text-sm lg:text-base leading-6 font-primary-font-light pb-8 md:pb-10 lg:pb-8 tracking-normal"
				>
					{{ heading }}
				</p>
				<div class="flex flex-col justify-center items-center">
					<MkPrimaryButton
						v-if="result"
						btn-class="min-w-150 h-10 py-3"
						button-title="Go to auto-refills"
						font-size="text-xl"
						@click="
							$router.push(`/D2C/account/autoRefills/`);
							closeModal();
						"
					/>
					<MkPrimaryButton
						v-else
						btn-class="min-w-150 h-10 py-3"
						:loading="loading"
						button-title="Yes"
						font-size="text-xl"
						@click="updateCustomer()"
						@keydown.enter="updateCustomer()"
					/>
					<div class="pt-8 md:pt-6">
						<button
							tabindex="0"
							class="focus:ring-black focus:ring-1 font-primary-font-light md:font-primary-font-bold text-base leading-6 edit-button cursor-pointer"
							@click="closeModal(), deleteCardFocus(type)"
							@keydown="focusToCloseField($event)"
						>
							Cancel
						</button>
					</div>
				</div>
			</template>
		</MkModal>
		<MkModal
			:header-title="title"
			:toggle-modal="showModal && updateModal"
			model-class="max-w-full md:max-w-md lg:max-w-xl items-center h-auto"
			modal-height="h-auto"
			modal-style="mx-4 md:mx-0 px-8"
			:focus-close="focusClose"
			@close-modal="addNewCardFocus"
		>
			<template #modalContent>
				<h2
					class="text-2xl lg:text-base2 font-secondary-font-regular leading-7 lg:leading-10 pb-8 md:pb-6 tracking-normal"
				>
					{{ title }}
				</h2>
				<p
					class="text-base md:text-sm lg:text-base leading-6 font-primary-font-light pb-8 md:pb-10 lg:pb-8 tracking-normal"
				>
					{{ heading }}
				</p>
				<div class="flex flex-col justify-center items-center">
					<MkPrimaryButton
						btn-class="min-w-150 h-10 py-3"
						:loading="loading"
						button-title="Yes"
						font-size="text-xl"
						@click="confirm()"
						@keydown.enter="confirm()"
					/>
					<div class="pt-8 md:pt-6">
						<button
							tabindex="0"
							class="focus:ring-black focus:ring-1 font-primary-font-light md:font-primary-font-bold text-base leading-6 edit-button cursor-pointer"
							@click="closeModal(), addNewCardFocus($event)"
							@keydown="focusToCloseField($event)"
						>
							No thanks
						</button>
					</div>
				</div>
			</template>
		</MkModal>
	</div>
</template>

<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkTerritoryButton from '~/components/D2C/atoms/MkTerritoryButton.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkAddressForm from '~/components/D2C/molecules/MkAddressForm.vue';
import MkAddNewCreditcard from '~/components/D2C/atoms/MkAddNewCreditcard.vue';
import MkModal from '~/components/D2C/molecules/MkModal.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkPageSpinner from '~/components/D2C/atoms/MkPageSpinner/MkPageSpinner.vue';
import MKAdyen from '~/components/D2C/molecules/MKAdyen.vue';
export default {
	name: 'AddressPayment',
	components: {
		MkTerritoryButton,
		MkPrimaryButton,
		MkAddressForm,
		ValidationObserver,
		MkAddNewCreditcard,
		MkModal,
		MkCheck,
		MkPageSpinner,
		MKAdyen,
	},
	data() {
		return {
			newAddressSuccessMessage: '',
			addShipping: false,
			addPayment: false,
			loading: false,
			disableTrue: false,
			action: 'ADD_PAYMENT',
			heading: '',
			type: '',
			buttonTitle: 'Save',
			editCreaditCard: false,
			paymentData: {},
			updateModal: false,
			deleteModal: false,
			inputAddress: {
				country: 'US',
			},
			result: false,
			pageLoading: false,
			currentEditIndex: 0,
			currentDeleteIndex: 0,
			currentIndex: 0,
			focusClose: false,
		};
	},
	head() {
		return {
			title: 'Address & Payment',
		};
	},
	computed: {
		SHIPPING_RESPONSE() {
			return this.$store.state.USER_STORE.SHIPPING_RESPONSE;
		},
		showModal() {
			return this.$store.state.MODAL_STORE.IS_ACTIVE;
		},
		...mapState(['isEurope']),
		...mapState('USER_STORE', [
			'SHIPPING_RESPONSE',
			'CREDIT_BILLING_RESPONSE',
			'CREDIT_CARD_DETAILS',
			'AUTHENTICATED',
			'CUSTOMERID',
			'CUSTOMER_SHIPPING_ADDRESS',
			'CUSTOMER_CREDIT_CARD_DETAILS',
			'SUBSCRIPTIONS',
			'API_RESPONSE_WAIT',
			'VALID_ADDRESS',
		]),
		...mapState('CHECKOUT_STORE', ['SHOW_PAGE_SPINNER']),
	},
	watch: {
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.getAccount();
			}
		},
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.getAccount();
		}
	},
	methods: {
		async getAccount() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		},
		addCancel() {
			this.$root.$utility.fieldFocus(this, 'add_new_address_button');
		},
		addNewCardFocus(event) {
			if (this.action === 'ADD_PAYMENT') {
				this.$root.$utility.fieldFocus(this, 'add_new_card_button');
			} else {
				const self = this;
				this.$nextTick().then(function () {
					self.$refs['edit-payment-btn'][self.currentEditIndex].focus();
				});
			}
		},
		deleteCardFocus(type) {
			const self = this;
			this.$nextTick().then(function () {
				if (type === 'payment') {
					self.$refs['delete-payment-btn'][self.currentDeleteIndex].focus();
				} else {
					self.$refs['delete-address-btn'][self.currentIndex].focus();
				}
			});
		},
		addCard(type) {
			this.inputAddress = {
				country: 'US',
			};
			this.buttonTitle = 'Save';
			this.type = type;
			if (type === 'address') {
				this.action = 'ADD_SHIPPING_ADDRESS';
				this.addShipping = !this.addShipping;
				this.addPayment = false;
				this.editCreaditCard = false;
			} else {
				this.action = 'ADD_PAYMENT';
				this.editCreaditCard = true;
				this.addPayment = !this.addPayment;
				this.addShipping = false;
				document.body.scrollTop = 0;
				document.documentElement.scrollTop = 0;
			}
		},
		async editCard(editData, index) {
			this.currentEditIndex = index;
			this.pageLoading = true;
			this.paymentData = editData;
			this.action = 'UPDATE_PAYMENT';
			this.title = 'payment';
			if (editData.defaultBillingAddress) {
				const address = editData.defaultBillingAddress;
				address.streetAddress1 = address.streetName;
				address.streetAddress2 = address.streetNumber ? address.streetNumber : '';
				address.phoneNumber = address.phone;
				this.inputAddress = Object.assign({}, address);
			}
			this.buttonTitle = 'Update card';

			this.result = await this.getSubscriptions({
				paymentId: editData.paymentId,
			});
			this.pageLoading = false;
			this.deleteModal = false;
			if (this.result) {
				let content = '';
				if (this.paymentData.expiredStatus) {
					content = 'invalid';
				}
				this.title = 'Update payment on other plans?';
				this.heading = `You have other auto-refill plans using the same ${content} payment info. To avoid future mishaps, would you like to also update those plans with this new payment?`;
				this.updateModal = true;
				this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
			} else {
				this.addShipping = false;
				this.addPayment = true;
				this.editCreaditCard = false;
				this.updateModal = false;
			}
		},
		async deleteCard(data, type, index) {
			this.pageLoading = true;
			this.type = type;
			this.result = false;
			if (type === 'payment') {
				this.currentDeleteIndex = index;
				this.action = 'REMOVE_PAYMENT';
				this.result = this.isEurope ? false : await this.getSubscriptions({ paymentId: data.paymentId });
				this.paymentData = data;
				this.inputAddress = data.defaultBillingAddress;
			} else {
				this.currentIndex = index;
				this.action = 'REMOVE_SHIPPING_ADDRESS';
				this.result = this.isEurope
					? false
					: await this.getSubscriptions({
							shippingAddressId: data.id,
					  });
				this.inputAddress = data;
			}
			this.pageLoading = false;
			this.updateModal = false;
			if (this.result) {
				this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
				this.deleteModal = true;
				this.title = 'Unable to delete';
				this.heading = `This ${type} is associated with one or more auto-refill plans. Please edit the auto-refill plan before deleting this ${type} .`;
			} else {
				this.title = 'Are you sure?';
				this.heading = `You’d like to delete this ${type} ?`;
				this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
				this.deleteModal = true;
			}
		},
		async getSubscriptions(payload) {
			await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', payload);
			if (this.SUBSCRIPTIONS.errorCode) {
				return false;
			} else if (this.SUBSCRIPTIONS.length) {
				this.selectedSubscription = this.SUBSCRIPTIONS;
				return true;
			}
		},
		// New API
		async updateCustomer() {
			const payload = {};
			payload.action = this.action;
			if (this.action !== 'REMOVE_PAYMENT' && this.action !== 'REMOVE_SHIPPING_ADDRESS') {
				this.inputAddress.streetName = this.inputAddress.streetAddress1;
				this.inputAddress.streetNumber = this.inputAddress.streetAddress2 ? this.inputAddress.streetAddress2 : '';
				this.inputAddress.phone = this.inputAddress.phoneNumber;
				this.inputAddress.isBusiness = false;
				this.inputAddress.company = '';
				this.inputAddress.region = this.inputAddress.state;
			}
			if (this.type === 'address') {
				payload.shippingAddress = this.inputAddress;
				payload.isDefaultAddress = false;
			} else {
				payload.billingAddress = this.inputAddress;
				if (this.action === 'UPDATE_PAYMENT' || this.action === 'REMOVE_PAYMENT') {
					payload.editCreaditCard = this.editCreaditCard;
					payload.isDefaultPayment = this.paymentData.defaultStatus;
					payload.paymentType = 'CREDITCARD';
					payload.paymentId = this.paymentData.paymentId;
					payload.paymentToken = this.paymentData.paymentToken;
				} else {
					payload.isDefaultPayment = false;
				}
			}
			let isValidForm = true;
			if (this.action !== 'REMOVE_SHIPPING_ADDRESS' && this.action !== 'REMOVE_PAYMENT') {
				isValidForm = await this.$refs.form_validation_observer.validate();
			}
			if (isValidForm && this.VALID_ADDRESS) {
				this.loading = true;
				try {
					const res = await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', payload);
					if (res === 'Success') {
						if (this.action === 'ADD_SHIPPING_ADDRESS') {
							this.newAddressSuccessMessage = 'Address has been saved successfully';
							const self = this;
							self.$refs.new_address_success_message.textContent = this.newAddressSuccessMessage;
						}
						await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
						this.addPayment = false;
						this.addShipping = false;
						this.deleteModal = false;
						this.updateModal = false;
						this.inputAddress = {};
						this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
						this.loading = false;
						this.deletedSuccess();
						if (this.action === 'UPDATE_PAYMENT') {
							this.addNewCardFocus();
						}
						this.addCancel();
					} else {
						this.loading = false;
					}
				} catch (exp) {
					this.loading = false;
				}
			}
		},
		deletedSuccess() {
			const self = this;
			this.$nextTick().then(function () {
				let index = 0;
				if (self.action === 'REMOVE_SHIPPING_ADDRESS') {
					if (self.CUSTOMER_SHIPPING_ADDRESS && self.CUSTOMER_SHIPPING_ADDRESS.length) {
						index = self.CUSTOMER_SHIPPING_ADDRESS.length - 1;
					}
					self.$refs['delete-address-btn'][index].focus();
				} else if (self.action === 'REMOVE_PAYMENT') {
					if (self.CUSTOMER_CREDIT_CARD_DETAILS && self.CUSTOMER_CREDIT_CARD_DETAILS.length) {
						index = self.CUSTOMER_CREDIT_CARD_DETAILS.length - 1;
					}
					self.$refs['delete-payment-btn'][index].focus();
				}
			});
		},
		closeModal() {
			this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
			this.deleteModal = false;
			this.updateModal = false;
		},
		selectCard(value) {
			this.editCreaditCard = !value;
		},
		confirm() {
			this.addShipping = false;
			this.addPayment = true;
			this.editCreaditCard = false;
			this.deleteModal = false;
			this.updateModal = false;
		},
		focusToCloseField(e) {
			if (e.keyCode === 9) {
				if (e.shiftKey) {
					// shiftkey will be undefined
				} else {
					e.preventDefault();
					this.focusClose = true;
					const self = this;
					setTimeout(function () {
						self.focusClose = false;
					}, 200);
				}
			}
		},
	},
};
</script>
<style lang="postcss">
.cc-input {
	width: 100%;

	@media (max-width: 900px) {
		width: 100%;
	}

	@media (max-width: 600px) {
		width: 100%;
	}
}

.btn-focus {
	@apply focus:outline-none focus:ring-1 focus:ring-black;
}
</style>
